#include <stdio.h>
#include <sys/shm.h>
#include <sys/msg.h>
#include <sys/stat.h>
#include <errno.h>
#include <sys/ipc.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#define BUFF_SIZE 1024

typedef struct{
	long mtype;
	char mtext[BUFF_SIZE];
} mymsg_t;

int main()
{
	void *shared_memory = (void *)0;
	char *message;
	int shmid;
	mymsg_t mymsg;
	key_t msg_key, shm_key;
	char flag = 0;

	if(-1 ==(shmid = shmget((key_t)2321, sizeof(char)*BUFF_SIZE, IPC_CREAT|0666)))
	{
		perror("shmget failed");
		exit(0);
	}

	if((shared_memory = shmat(shmid, (void *)0, 0)) == (void *)-1)
	{
		perror("shmat failed");
		exit(0);               
	}

	message = (char *)shared_memory;
	if(0 > (msg_key = msgget(2234, IPC_CREAT|0666)))                                                          
	{
		perror("msgget error:");
		exit(0);
	}
	while(1)
	{          
		if(-1 == (msgrcv(msg_key, (void *)&mymsg, sizeof(mymsg_t), 1, MSG_NOERROR)))
		{      
			perror("msgrcv error:");
			exit(0);
		}
		flag++;
        memcpy(message,&flag,1);        
		memcpy(message+1, mymsg.mtext, 1);   //argv[1]  message+1 저장
		memcpy(message+2 , mymsg.mtext+1, BUFF_SIZE);
	}            //입력된 메시지 message+2 저장
	return 0;
}

